//+------------------------------------------------------------------+
//|                                                Turkm_beka_v1.mq4 |
//|                          Copyright 2013,  Forex Programming site |
//|                                                http://1234ex.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

extern bool  UseTimeFilter = false;        
extern string  StartTime = "00:00";            
extern string  EndTime = "23:00"; 
extern string  S0 = " ++++++++++++++++++++ ";
 bool UseMultiplier=false;
 bool X_Multiplier=false;
 bool Sum_Multiplier=false;
 double Multiplier=1.3;
extern int Slippage = 3;
extern double Lots = 0.1;          
 bool  UseMoneyManagement = false;                 
 double  RiskPercent = 1;         

extern string S4="---------------- Order Management";
extern int StopLoss=50;
extern int TakeProfit=50;
extern double DifferenceBetweenOpenClose = 0.6;
 int TrailingStop=0;
 int TrailingStep=0;
 
bool Sell=false,Buy=false; 
static datetime TimeSell, TimeBuy;
double point;
int digits,Q;
extern int MagicNumber=4363736;
 
 
int OnInit()
  {
//--- create timer
   
   if(Digits==5||Digits==3)Q=10;
   else Q=1;                     
   TimeSell=Time[0];
   TimeBuy=Time[0];
   if(Digits<4)
   {
      point=0.01;
      digits=2;
   }
   else
   {
      point=0.0001;
      digits=4;
   }
   
   EventSetTimer(60);
      
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
     //static datetime prevtime=0; 
     //if(prevtime == Time[0]) {return(0);}
     //prevtime = Time[0];
   
     datetime Start= StrToTime(TimeToStr(TimeCurrent(), TIME_DATE) + " " + StartTime);
     datetime End= StrToTime(TimeToStr(TimeCurrent(), TIME_DATE) + " " + EndTime);
     if (UseTimeFilter)
     {
         if(!(Time[0]>=Start && Time[0]<=End))
         {
           Comment("Non-Trading Hours!");
         }
      }
   
   double NewLot;
   double lot=LastLot();
   if(UseMultiplier)
   {
      if(X_Multiplier && !Sum_Multiplier)
      {
         NewLot=lot*Multiplier;
         NormalizeDouble(NewLot,2);
      }
      if(Sum_Multiplier && !X_Multiplier)
      {
         NewLot=lot+Multiplier;
         NormalizeDouble(NewLot,2);
      }
    }
    else NewLot=lot+Lots;
///             End Multiply Section               /// 
///################################################///
  
   if(UseMoneyManagement)
   {
      Lots=LotManage();
   }
   
   if(TrailingStop>0)MoveTrailingStop();
   
   
////////////////////////////////////////////////// 
//       Here you wirite your conditions        //
   double SL,TP,Differenc;   
   
   int Bar_Shift_FromStartingDay = iBarShift(Symbol(), PERIOD_M5, iTime(Symbol(),PERIOD_D1,0))-1;
   if(MathMod(Bar_Shift_FromStartingDay,10) == 0 && Bar_Shift_FromStartingDay <=280)
   {
      Differenc = NormalizeDouble(MathAbs(Close[Bar_Shift_FromStartingDay] - Open[Bar_Shift_FromStartingDay - 9]) / point, digits);
      if(Close[1] > Open[10])
      {
         if(TimeSell!=Time[0] && Differenc >= DifferenceBetweenOpenClose)
         {
            if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*point;}
            if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*point;}
            OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage*Q,SL,TP,"1111_v1",MagicNumber,0,Red); 
            TimeSell=Time[0]; 
         }
      }
      else
      {
         if(TimeBuy!=Time[0] && Differenc >= DifferenceBetweenOpenClose)
         {
            if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*point;}
            if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*point;}
            OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage*Q,SL,TP,"1111_v1",MagicNumber,0,Blue);
            TimeBuy=Time[0];
         }
      }
      Comment(Differenc);
   }
   
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }

int orderscnt()
{
   int cnt=0;
   for(int i =0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderSymbol()==Symbol() && MagicNumber==OrderMagicNumber())
         {
            cnt++;
         }
     }
   }
    return(cnt);
}
double LotManage()
{
     double Lot = MathCeil(AccountFreeMargin() *  RiskPercent / 1000) / 100; 
	  if(Lot<MarketInfo(Symbol(),MODE_MINLOT))Lot=MarketInfo(Symbol(),MODE_MINLOT);
	  if(Lot>MarketInfo(Symbol(),MODE_MAXLOT))Lot=MarketInfo(Symbol(),MODE_MAXLOT);
	  return (Lot);
}
void MoveTrailingStop()
{
   int cnt,total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(TrailingStop>0
            && Bid-OrderOpenPrice()>point*TrailingStop
            && OrderStopLoss()<Bid-point*TrailingStop)
            {               
               if((NormalizeDouble(OrderStopLoss(),digits)<NormalizeDouble(Bid-point*TrailingStop,digits))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-point*TrailingStop,digits),OrderTakeProfit(),0,Blue);
                  //return(0);
               }
            }
         }
         else 
         {
            if(TrailingStop>0
            && OrderOpenPrice()-Ask>point*TrailingStop
            && (OrderStopLoss()>Ask+point*TrailingStop || OrderStopLoss()==0))
            {                 
               if((NormalizeDouble(OrderStopLoss(),digits)>(NormalizeDouble(Ask+point*TrailingStop,digits)))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+point*TrailingStop,digits),OrderTakeProfit(),0,Red);
                  //return(0);
               }
            }
         }
      }
   }
}

double LastLot()
{
   double lastlot_1= 0.0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && MagicNumber ==OrderMagicNumber())
      {
         lastlot_1=OrderLots();
      }
   } 
   return(lastlot_1);
}
int last_type() 
{
   int type = -1;
   for (int i = 0; i < OrdersTotal(); i++) 
   {
      OrderSelect(i, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() <= OP_SELL) type = OrderType();
   }
   return (type);
}

double last_open(int type) 
{
   double open = 0.0;
   for (int i = 0; i < OrdersTotal(); i++) 
   {
      OrderSelect(i, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == type) open = OrderOpenPrice();
   }
   return(open);
}
double profit_By_type(int type) 
{
   double profit = 0.0;
   for (int i = 0; i < OrdersTotal(); i++) 
   {
      OrderSelect(i, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderType() == type) profit += OrderProfit();
   }
   return (profit);
}

void Delete(int type)
{
   for(int a=0;a<OrdersTotal();a++)
   { 
      OrderSelect(a,SELECT_BY_POS,MODE_TRADES); 
      if(OrderSymbol() == Symbol() && OrderType()==type)
      {
         OrderDelete(OrderTicket());
      }
   }
} 